﻿Type=Service
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region - Made modifications sources newinst2 by: UDG - Di Gioia Consulting - Lugano (CH)
	'****************************************************************************************
	' Service module: NewInstall
	' Version: 1.00
	' Author: T201016
	' Last Modified: 28.08.2017
	' Location: T201016 - FORUM - B4X Developers (http://www.b4x.com/android/forum/)
	'****************************************************************************************
#End Region
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	Log("---- AppUpdate.newinstall: service created")
	Dim apkupdt As AppUpdate
	apkupdt.gv.pkg = ""
	apkupdt.gv.svcVerbose = False
End Sub

Sub Service_Start (StartingIntent As Intent)
	Log("---- AppUpdate.newinstall: service_started")
	Dim apkupdt As AppUpdate
	If apkupdt.gv.svcVerbose Then
		Log(TAB & "intent: " & StartingIntent)
		Log(TAB & "action: " & StartingIntent.Action)
		Log(TAB & "extra: " & StartingIntent.ExtrasToString)
		Log(TAB & "data: " & StartingIntent.GetData)
	End If		
	If StartingIntent.Action = "android.intent.action.PACKAGE_REPLACED" Then
		If apkupdt.gv.svcVerbose Then Log(TAB & "Package REPLACED intent received!")
		apkupdt.gv.pkg = GetPackageName
		If apkupdt.gv.svcVerbose Then Log(TAB & "package: " & apkupdt.gv.pkg)
		If StartingIntent.GetData="package:" & apkupdt.gv.pkg Then
			MyAppReload(apkupdt.gv.svcVerbose)
		End If
	End If	
End Sub

Sub Service_Destroy
End Sub

Sub GetPackageName As String
	Dim r As Reflector
	Return r.GetStaticField("anywheresoftware.b4a.BA", "packageName")
End Sub

Sub MyAppReload (svcVerbose As Boolean)
	If svcVerbose Then Log("---- AppUpdate.newinstall: processing MyAppReload")
	If IsPaused(Main) Then
		StartActivity(Main)
	End If
End Sub